using System.Text.Json;
using System.Text.Json.Serialization;
using Amazon.Lambda.Serialization.SystemTextJson;

namespace HandlingNumbersAsStringsInJson;

public class NumbersAsStringsSerializer : DefaultLambdaJsonSerializer
{
    public NumbersAsStringsSerializer()
        : base(ConfigureJsonSerializerOptions) { }

    private static void ConfigureJsonSerializerOptions(JsonSerializerOptions options)
    {
        options.NumberHandling = JsonNumberHandling.AllowReadingFromString;
    }

    // This is a shorter version of the above
    // public NumbersAsStringsSerializer()
    //    : base((options) => options.NumberHandling = JsonNumberHandling.AllowReadingFromString) { }
}